' test.bas
' tests fsp 2.1 from ZXBasic

#include once "fsp2.1.bas"
#include once "spritegfxdata.bas"

' Vamos a probar fsp

Dim spX (3) As uByte
Dim spY (3) As uByte
Dim spMX (3) As Byte
Dim spMY (3) As Byte

Dim i As Byte
Dim j As Byte

For i = 0 To 3
	spX (i) = Int (Rnd * 29) + 1
	spY (i) = Int (Rnd * 15) + 6
	spMX (i) = 2 * (Int (Rnd * 2)) - 1				' Random (-1  1)
	spMY (i) = 2 * (Int (Rnd * 2)) - 1
Next i

fsp21SetGfxAddress (@spriteGfxData (0))				' Direccin de los grficos.

For i = 0 To 3
	fsp21MoveSprite (i, spX (i), spY (i))			' Posicin inicial sprite i
	fsp21DuplicateCoordinatesSprite (i)				' Establecer CX y CY la primera vez
	fsp21ColourSprite (	i, _
						4 + i, _
						4 + i, _
						4 + i, _
						4 + i)						' Color del sprite
	fsp21SetGfxSprite (	i, _
						4 * i, _
						4 * i + 1, _
						4 * i + 2, _
						4 * i + 3)					' Grficos del sprite
	fsp21ActivateSprite (i)							' Activar el Sprite i
Next i

While Code (Inkey ()) <> 0: Wend					' Clear keybuff

j = 0
For i = 0 To 23
	Print At i, 0; Paper j; "                                ";
	j = j + 1
	If j = 4 Then 
		j = 0
	End If
Next i

fsp21InitSprites ()									' Inicializamos el sistema

'' Animacin

While Code (Inkey ()) = 0
	
	' Update
	For i = 0 To 3
		spX (i) = spX (i) + spMX (i)
		spY (i) = spY (i) + spMY (i)
		
		If spX (i) = 0 Or spX (i) = 30 Then 
			spMX (i) = -spMX (i)
		End If
		
		If spY (i) = 5 Or spY (i) = 22 Then 
			spMY (i) = -spMY (i)
		End If
		
		fsp21MoveSprite (i, spX (i), spY (i))
	Next i
	
	fsp21UpdateSprites ()
Wend


